/*
*  This script defines functions used by Options window
*
* Author: Stphane BERTIN
* http://bookmarkdd.mozdev.org
*
*/

//If dialog window is the window to select folder modify the default design.
var dialogID = document.getElementById("newBookmarkDialog");
if(dialogID){
    StartupCustomized();
    /*TODO increase tree's height
    var gBookmarksTree = document.getElementById("bookmarks-view");
    var originalTreeHeight = gBookmarksTree.getAttribute("height");
    //dialogID.style="width: 36em; height: 180em;";
    gBookmarksTree.setAttribute("height", originalTreeHeight*2);
    */
}


//Function used to customize addBookmark.xul to achieve our needs: select folder design
function StartupCustomized(){
    var movetoLabel = document.getElementById("movetolabel");//.setAttribute("hidden", "true");
    var labelValue = Bookmarkdd.searchStringLocalisation("Options.SelectFolder.label");
    var newLabel = document.createElement("label");
    newLabel.setAttribute("value",labelValue);
    document.getElementById("movetolabel").parentNode.replaceChild(newLabel, movetoLabel);

    var buttonNewFolder = dialogID.getElementsByAttribute("oncommand","createNewFolder();")
    buttonNewFolder[0].hidden = true;

}

// Select Bookmarks folder
function selectBMFolder(){
    var rv = { selectedFolder: null };      
    openDialog("chrome://browser/content/bookmarks/addBookmark.xul", "", 
               "centerscreen,chrome,modal=yes,dialog=yes,resizable=yes", null, 
               null, null, null, "selectFolder", rv);
    if (!rv.target) return; //If no folder is selected abort
    var targetResource = rv.target.parent;
    var targetName = BookmarksUtils.getProperty(targetResource.Value,gNCNS+"Name");
    var targetPath = Bookmarkdd.findPath(targetResource);

    //WARNING message: selection of root Folder 'Bookmarks' will delete ONLY duplicates which aren't in subfolders.
    //If you want to modify separator ' > ' you need to also modify it in ManageDuplicates.js
    var targetFolder = "";
    if(targetPath){
	targetFolder = targetPath+" > "+targetName;
    } else {
	targetFolder = targetName;
	//var warning = Bookmarkdd.searchStringLocalisation("Options.SelectFolder.Warning");
    	//alert(warning);
    }
	var textBoxFolder = document.getElementById("opt-selected-folder");
	textBoxFolder.value = targetFolder;
	UserPrefs.setPref("string","AutoDelete.SelectedFolder",targetFolder);

}


// enable / disable folder field and button
function VerifyFolderStatus(){
    var checkBox = document.getElementById("opt-AutoDelete.BookmarkInSelectedFolder");
    if (checkBox.checked) {
	document.getElementById("opt-selected-folder").disabled = false;
	document.getElementById("select-bm-folder").disabled = false;
    } else {
	document.getElementById("opt-selected-folder").disabled = true;
	document.getElementById("select-bm-folder").disabled = true;
    }
}

// Verify if 'Add Bookmark Here' extension is installed
// If installed available the option for support
function VerifyAddBookmarkHere(){

    //extensionManager not implemented in Firefox 1.0
    if (Bookmarkdd.version == "1.0") {
	document.getElementById("opt-miscellaneous.addBookmarkHere").setAttribute("hidden", "true");
    	return;
    }

    const ADD_BOOKMARK_HERE_ID = "{F33233B3-EDB1-41f4-8482-917AB190E647}";
    var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
			    .getService(Components.interfaces.nsIExtensionManager);
    var addBookmarkHere = extensionManager.getItemForID(ADD_BOOKMARK_HERE_ID);
    if (addBookmarkHere.version){
	var messageText = Bookmarkdd.searchStringLocalisation("Options.Miscellaneous.AddBookmarkHere.Info");
	var messageParent = document.getElementById("addBookmarkHere-information");
	var messageParagraphs = messageText.split("\n");

	for (var i = 0; i < messageParagraphs.length; i++) {
	    var descriptionNode = document.createElement("description");
	    var text = document.createTextNode(messageParagraphs[i]);
	    descriptionNode.appendChild(text);
	    messageParent.appendChild(descriptionNode);
	}
    } else {
	document.getElementById("opt-miscellaneous.addBookmarkHere").disabled = true;
    }

}

function OptionsOnLoad(){
    //Synchronise button and field with autodelete checkBox options
    VerifyFolderStatus();

    //Add 'Add Bookmark Here' support option if extension is installed
    VerifyAddBookmarkHere();

    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
    			getService(Components.interfaces.nsIPrefService);
    prefService = prefService.getBranch("browser.");
    var prefvalue = "None";
    try {
	prefvalue = prefService.getCharPref("bookmarks.file");
    } catch(e){
	prefvalue = Components.classes["@mozilla.org/file/directory_service;1"].
			getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
	prefvalue.append("bookmarks.html");
	prefvalue = prefvalue.path;
    }
    document.getElementById("opt-backup-folder").value = prefvalue;

    showBackupList();

}


// List bookmarkbackups folder's content
function showBackupList(){

    if (Bookmarkdd.version == "1.0") {
	document.getElementById("BookmarkBackupBOX").setAttribute("hidden", "true");
    	return;
    }

    var BackupPath = Components.classes["@mozilla.org/file/directory_service;1"].
    			getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile).path;

    var BackupFolder = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    BackupFolder.initWithPath(BackupPath);
    BackupFolder.append("bookmarkbackups");

    var Backupslist = document.getElementById("Backupslist");
    //to list folder's files: selectedFolder.directoryEntries
    var folderEnum = BackupFolder.directoryEntries;
    var index = 0;
    while(folderEnum.hasMoreElements()) {
	var file = folderEnum.getNext();
	var fileSupport = file.QueryInterface(Components.interfaces.nsIFile);
	Backupslist.appendItem(fileSupport.leafName,index);
	index++;
    }
}

// Select a system folder to change where are stored bookmarks.html and bookmarks.bak
// It is not possible to change path of backup folder %profileFolder%/bookmarksbackup
//http://lxr.mozilla.org/mozilla/source/browser/components/bookmarks/src/nsBookmarksService.cpp#4371
// Both following variables need to be global
var overwriteFile = false;
var changeBookmarksLocation = false;
function selectSystemFolder(){

    var localizedStrings = Bookmarkdd.searchStringLocalisation("Options.SelectFolder.label");

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, localizedStrings, nsIFilePicker.modeGetFolder);

    //fp.init(window, "Select a file: ", nsIFilePicker.modeOpen);
    //fp.appendFilters(nsIFilePicker.filterHTML | nsIFilePicker.filterAll);
    //fp.defaultString = "bookmarks.html";

    //to add a default folder when the window opens: fp.displayDirectory
    var res = fp.show();
    if (res == nsIFilePicker.returnOK){
	var selectedFolder = fp.file;
	var bookmarksFile = selectedFolder.path;
	var FolderSupport = selectedFolder.QueryInterface(Components.interfaces.nsIFile);
	FolderSupport.append("bookmarks.html");
	var fileName = FolderSupport.path;
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].
				getService(Components.interfaces.nsIPrefService);

	prefService = prefService.getBranch("browser.");
	var prefvalue = "None";
	try {
	    var file = Components.classes["@mozilla.org/file/local;1"]
		       .createInstance(Components.interfaces.nsILocalFile);
	    if (!file)
		return;
	    file.initWithPath(fileName);
	    if (!file.exists()) {
		changeBookmarksLocation = true;
	    } else {
		changeBookmarksLocation = true;
		window.openDialog("chrome://duplicates/content/ConfirmOverwriteBookmarks.xul", "confirm-overwrite-bookmark", "chrome,modal,alwaysRaised,resizable,centerscreen", null);
		//alert("User response is: "+overwriteFile + changeBookmarksLocation);
	    }

	    if (changeBookmarksLocation) {
		prefvalue = prefService.setCharPref("bookmarks.file",fileName);
		document.getElementById("opt-backup-folder").value = fileName;
		updateBookmarksFileLabel();
	    	if (overwriteFile) {
		    UserPrefs.setPref("bool","BookmarksFile.export",true);
		} else {
		    UserPrefs.setPref("bool","BookmarksFile.export",false);
		}
	    }

	    //Try to use new bookmarks file
	    //initBMService();

	} catch(e){
	    var error = Bookmarkdd.searchStringLocalisation("Error.ChangeBookmarksFolder");
	    alert(error);
	    Bookmarkdd.myDump("ERROR: Impossible to change bookmarks folder.\n\n"+e);
	}
	//initBMService();
	//BMSVC.readBookmarks();
	/*var obj = Components.classes["@mozilla.org/browser/bookmarks-service;1"].
	getService(Components.interfaces.nsIBookmarksService);
	obj.LoadBookmarks();*/

    } else {
    	return;
    }
    
    return;

}


// Restore the default folder of Bookmarks backup
// default folder %profileFolder%/bookmarksbackup
// ProfD: User profile directory, BMarks: bookmarks file ~? browser.bookmarks.file
function restoreDefaultSystemFolder(){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
    			getService(Components.interfaces.nsIPrefService);

    prefService = prefService.getBranch("browser.");
    var prefvalue = "None";
    try {
	prefvalue = prefService.getCharPref("bookmarks.file");
	var fileName = Components.classes["@mozilla.org/file/directory_service;1"].
			getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
	fileName.append("bookmarks.html");
	fileName = fileName.path;


	//var warning = Bookmarkdd.searchStringLocalisation("Warning.BookmarkFile.exist");
	// Do you want to overwrite bookmarks.html file ? Yes = overwrite No = use file already in folder
	//if ( confirm(warning) ) UserPrefs.setPref("bool","BookmarksFile.export",true);

	var file = Components.classes["@mozilla.org/file/local;1"]
		   .createInstance(Components.interfaces.nsILocalFile);
	if (!file)
	    return;
	file.initWithPath(fileName);
	if (!file.exists()) {
	    changeBookmarksLocation = true;
	} else {
	    changeBookmarksLocation = true;
	    window.openDialog("chrome://duplicates/content/ConfirmOverwriteBookmarks.xul", "confirm-overwrite-bookmark", "chrome,modal,alwaysRaised,resizable,centerscreen", null);
	    //alert("User response is: "+overwriteFile + changeBookmarksLocation);
	}

	if (changeBookmarksLocation) { //Restore default bookmarks path
	    if (prefvalue) prefService.deleteBranch("bookmarks.file");
	    document.getElementById("opt-backup-folder").value = fileName;
	    updateBookmarksFileLabel();

	    if (overwriteFile) {
		UserPrefs.setPref("bool","BookmarksFile.export",true);
	    } else {
		UserPrefs.setPref("bool","BookmarksFile.export",false);
	    }
	}

    } catch(e){
	var warning = Bookmarkdd.searchStringLocalisation("Warning.AlreadyDefaultFolder");
	alert(warning);
	Bookmarkdd.myDump("Information: Already bookmarks default folder.\n\n"+e);
    }
}

// When bookmarks file change we need to update option.xul sentence
function updateBookmarksFileLabel(){
    var newLabel = Bookmarkdd.searchStringLocalisation("NextBookmarksFile.label");
    var label = document.getElementById("bookmarks-file-label");
    label.value = newLabel;
}


// Restore a file selected within folder 'bookmarkbackups'
//Confirmation.restoreBookmarksBackup
//Warning.restoreBookmarksBackup
//Warning.restartFirefox
function restoreBackup(){
}

// Function to synchronise Menu with User's preferences
// It is executed when Options.xul Unload and when Firefox Load (duplicates.xul eventListener)
function VerifyMenuItemStatus() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		.getService(Components.interfaces.nsIWindowMediator);
    var enumerator = wm.getEnumerator("");
    var enumBreak = 0;

    while(enumerator.hasMoreElements()) {
	var win = enumerator.getNext();
	// |win| is [Object ChromeWindow] (just like |window|), do something with it
	// Verify if BookmarksMenu's hidden property is synchronised with UserPrefs
	var BookmarksMenu=win.document.getElementById("BookmarkDD-context-menu");
	if(BookmarksMenu) {
	    if(!UserPrefs.getPref("bool","BookmarksMenu.addLink")) {
		BookmarksMenu.setAttribute('hidden',true);
	    } else {
		BookmarksMenu.setAttribute('hidden',false);
	    }
	    enumBreak++;
	}
	// Verify if ToolsMenu's hidden property is synchronised with UserPrefs
	var ToolsMenu=win.document.getElementById("BookmarkDD-PanelLink");
	if(ToolsMenu) {
	    if(!UserPrefs.getPref("bool","ToolsMenu.addLink")) {
		ToolsMenu.setAttribute('hidden',true);
	    } else {
		ToolsMenu.setAttribute('hidden',false);
	    }
	    enumBreak++;
	}
	if(enumBreak>0) break;
    }

}
